<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>18.3. select — Waiting for I/O completion &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="18. Interprocess Communication and Networking" href="ipc.html" />
    <link rel="next" title="18.4. selectors – High-level I/O multiplexing" href="selectors.html" />
    <link rel="prev" title="18.2. ssl — TLS/SSL wrapper for socket objects" href="ssl.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="selectors.html" title="18.4. selectors – High-level I/O multiplexing"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="ssl.html" title="18.2. ssl — TLS/SSL wrapper for socket objects"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="ipc.html" accesskey="U">18. Interprocess Communication and Networking</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-select">
<span id="select-waiting-for-i-o-completion"></span><h1>18.3. <a class="reference internal" href="#module-select" title="select: Wait for I/O completion on multiple streams."><code class="xref py py-mod docutils literal"><span class="pre">select</span></code></a> &#8212; Waiting for I/O completion<a class="headerlink" href="#module-select" title="Permalink to this headline">¶</a></h1>
<p>This module provides access to the <code class="xref c c-func docutils literal"><span class="pre">select()</span></code> and <code class="xref c c-func docutils literal"><span class="pre">poll()</span></code> functions
available in most operating systems, <code class="xref c c-func docutils literal"><span class="pre">devpoll()</span></code> available on
Solaris and derivatives, <code class="xref c c-func docutils literal"><span class="pre">epoll()</span></code> available on Linux 2.5+ and
<code class="xref c c-func docutils literal"><span class="pre">kqueue()</span></code> available on most BSD.
Note that on Windows, it only works for sockets; on other operating systems,
it also works for other file types (in particular, on Unix, it works on pipes).
It cannot be used on regular files to determine whether a file has grown since
it was last read.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The <a class="reference internal" href="selectors.html#module-selectors" title="selectors: High-level I/O multiplexing."><code class="xref py py-mod docutils literal"><span class="pre">selectors</span></code></a> module allows high-level and efficient I/O
multiplexing, built upon the <a class="reference internal" href="#module-select" title="select: Wait for I/O completion on multiple streams."><code class="xref py py-mod docutils literal"><span class="pre">select</span></code></a> module primitives. Users are
encouraged to use the <a class="reference internal" href="selectors.html#module-selectors" title="selectors: High-level I/O multiplexing."><code class="xref py py-mod docutils literal"><span class="pre">selectors</span></code></a> module instead, unless they want
precise control over the OS-level primitives used.</p>
</div>
<p>The module defines the following:</p>
<dl class="exception">
<dt id="select.error">
<em class="property">exception </em><code class="descclassname">select.</code><code class="descname">error</code><a class="headerlink" href="#select.error" title="Permalink to this definition">¶</a></dt>
<dd><p>A deprecated alias of <a class="reference internal" href="exceptions.html#OSError" title="OSError"><code class="xref py py-exc docutils literal"><span class="pre">OSError</span></code></a>.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.3: </span>Following <span class="target" id="index-0"></span><a class="pep reference external" href="https://www.python.org/dev/peps/pep-3151"><strong>PEP 3151</strong></a>, this class was made an alias of <a class="reference internal" href="exceptions.html#OSError" title="OSError"><code class="xref py py-exc docutils literal"><span class="pre">OSError</span></code></a>.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="select.devpoll">
<code class="descclassname">select.</code><code class="descname">devpoll</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#select.devpoll" title="Permalink to this definition">¶</a></dt>
<dd><p>(Only supported on Solaris and derivatives.)  Returns a <code class="docutils literal"><span class="pre">/dev/poll</span></code>
polling object; see section <a class="reference internal" href="#devpoll-objects"><span>/dev/poll Polling Objects</span></a> below for the
methods supported by devpoll objects.</p>
<p><code class="xref c c-func docutils literal"><span class="pre">devpoll()</span></code> objects are linked to the number of file
descriptors allowed at the time of instantiation. If your program
reduces this value, <code class="xref c c-func docutils literal"><span class="pre">devpoll()</span></code> will fail. If your program
increases this value, <code class="xref c c-func docutils literal"><span class="pre">devpoll()</span></code> may return an
incomplete list of active file descriptors.</p>
<p>The new file descriptor is <a class="reference internal" href="os.html#fd-inheritance"><span>non-inheritable</span></a>.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.3.</span></p>
</div>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>The new file descriptor is now non-inheritable.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="select.epoll">
<code class="descclassname">select.</code><code class="descname">epoll</code><span class="sig-paren">(</span><em>sizehint=-1</em>, <em>flags=0</em><span class="sig-paren">)</span><a class="headerlink" href="#select.epoll" title="Permalink to this definition">¶</a></dt>
<dd><p>(Only supported on Linux 2.5.44 and newer.) Return an edge polling object,
which can be used as Edge or Level Triggered interface for I/O
events. <em>sizehint</em> is deprecated and completely ignored. <em>flags</em> can be set
to <code class="xref py py-const docutils literal"><span class="pre">EPOLL_CLOEXEC</span></code>, which causes the epoll descriptor to be closed
automatically when <a class="reference internal" href="os.html#os.execve" title="os.execve"><code class="xref py py-func docutils literal"><span class="pre">os.execve()</span></code></a> is called.</p>
<p>See the <a class="reference internal" href="#epoll-objects"><span>Edge and Level Trigger Polling (epoll) Objects</span></a> section below for the methods supported by
epolling objects.</p>
<p><code class="docutils literal"><span class="pre">epoll</span></code> objects support the context management protocol: when used in a
<a class="reference internal" href="../reference/compound_stmts.html#with"><code class="xref std std-keyword docutils literal"><span class="pre">with</span></code></a> statement, the new file descriptor is automatically closed
at the end of the block.</p>
<p>The new file descriptor is <a class="reference internal" href="os.html#fd-inheritance"><span>non-inheritable</span></a>.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.3: </span>Added the <em>flags</em> parameter.</p>
</div>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>Support for the <a class="reference internal" href="../reference/compound_stmts.html#with"><code class="xref std std-keyword docutils literal"><span class="pre">with</span></code></a> statement was added.
The new file descriptor is now non-inheritable.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="select.poll">
<code class="descclassname">select.</code><code class="descname">poll</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#select.poll" title="Permalink to this definition">¶</a></dt>
<dd><p>(Not supported by all operating systems.)  Returns a polling object, which
supports registering and unregistering file descriptors, and then polling them
for I/O events; see section <a class="reference internal" href="#poll-objects"><span>Polling Objects</span></a> below for the methods supported
by polling objects.</p>
</dd></dl>

<dl class="function">
<dt id="select.kqueue">
<code class="descclassname">select.</code><code class="descname">kqueue</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#select.kqueue" title="Permalink to this definition">¶</a></dt>
<dd><p>(Only supported on BSD.)  Returns a kernel queue object; see section
<a class="reference internal" href="#kqueue-objects"><span>Kqueue Objects</span></a> below for the methods supported by kqueue objects.</p>
<p>The new file descriptor is <a class="reference internal" href="os.html#fd-inheritance"><span>non-inheritable</span></a>.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.4: </span>The new file descriptor is now non-inheritable.</p>
</div>
</dd></dl>

<dl class="function">
<dt id="select.kevent">
<code class="descclassname">select.</code><code class="descname">kevent</code><span class="sig-paren">(</span><em>ident</em>, <em>filter=KQ_FILTER_READ</em>, <em>flags=KQ_EV_ADD</em>, <em>fflags=0</em>, <em>data=0</em>, <em>udata=0</em><span class="sig-paren">)</span><a class="headerlink" href="#select.kevent" title="Permalink to this definition">¶</a></dt>
<dd><p>(Only supported on BSD.)  Returns a kernel event object; see section
<a class="reference internal" href="#kevent-objects"><span>Kevent Objects</span></a> below for the methods supported by kevent objects.</p>
</dd></dl>

<dl class="function">
<dt id="select.select">
<code class="descclassname">select.</code><code class="descname">select</code><span class="sig-paren">(</span><em>rlist</em>, <em>wlist</em>, <em>xlist</em><span class="optional">[</span>, <em>timeout</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#select.select" title="Permalink to this definition">¶</a></dt>
<dd><p>This is a straightforward interface to the Unix <code class="xref c c-func docutils literal"><span class="pre">select()</span></code> system call.
The first three arguments are sequences of &#8216;waitable objects&#8217;: either
integers representing file descriptors or objects with a parameterless method
named <a class="reference internal" href="io.html#io.IOBase.fileno" title="io.IOBase.fileno"><code class="xref py py-meth docutils literal"><span class="pre">fileno()</span></code></a> returning such an integer:</p>
<ul class="simple">
<li><em>rlist</em>: wait until ready for reading</li>
<li><em>wlist</em>: wait until ready for writing</li>
<li><em>xlist</em>: wait for an &#8220;exceptional condition&#8221; (see the manual page for what
your system considers such a condition)</li>
</ul>
<p>Empty sequences are allowed, but acceptance of three empty sequences is
platform-dependent. (It is known to work on Unix but not on Windows.)  The
optional <em>timeout</em> argument specifies a time-out as a floating point number
in seconds.  When the <em>timeout</em> argument is omitted the function blocks until
at least one file descriptor is ready.  A time-out value of zero specifies a
poll and never blocks.</p>
<p>The return value is a triple of lists of objects that are ready: subsets of the
first three arguments.  When the time-out is reached without a file descriptor
becoming ready, three empty lists are returned.</p>
<p id="index-1">Among the acceptable object types in the sequences are Python <a class="reference internal" href="../glossary.html#term-file-object"><span class="xref std std-term">file
objects</span></a> (e.g. <code class="docutils literal"><span class="pre">sys.stdin</span></code>, or objects returned by
<a class="reference internal" href="functions.html#open" title="open"><code class="xref py py-func docutils literal"><span class="pre">open()</span></code></a> or <a class="reference internal" href="os.html#os.popen" title="os.popen"><code class="xref py py-func docutils literal"><span class="pre">os.popen()</span></code></a>), socket objects returned by
<a class="reference internal" href="socket.html#socket.socket" title="socket.socket"><code class="xref py py-func docutils literal"><span class="pre">socket.socket()</span></code></a>.  You may also define a <em class="dfn">wrapper</em> class yourself,
as long as it has an appropriate <a class="reference internal" href="io.html#io.IOBase.fileno" title="io.IOBase.fileno"><code class="xref py py-meth docutils literal"><span class="pre">fileno()</span></code></a> method (that
really returns a file descriptor, not just a random integer).</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last" id="index-2">File objects on Windows are not acceptable, but sockets are.  On Windows,
the underlying <code class="xref c c-func docutils literal"><span class="pre">select()</span></code> function is provided by the WinSock
library, and does not handle file descriptors that don&#8217;t originate from
WinSock.</p>
</div>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span>The function is now retried with a recomputed timeout when interrupted by
a signal, except if the signal handler raises an exception (see
<span class="target" id="index-3"></span><a class="pep reference external" href="https://www.python.org/dev/peps/pep-0475"><strong>PEP 475</strong></a> for the rationale), instead of raising
<a class="reference internal" href="exceptions.html#InterruptedError" title="InterruptedError"><code class="xref py py-exc docutils literal"><span class="pre">InterruptedError</span></code></a>.</p>
</div>
</dd></dl>

<dl class="attribute">
<dt id="select.PIPE_BUF">
<code class="descclassname">select.</code><code class="descname">PIPE_BUF</code><a class="headerlink" href="#select.PIPE_BUF" title="Permalink to this definition">¶</a></dt>
<dd><p>The minimum number of bytes which can be written without blocking to a pipe
when the pipe has been reported as ready for writing by <a class="reference internal" href="#select.select" title="select.select"><code class="xref py py-func docutils literal"><span class="pre">select()</span></code></a>,
<a class="reference internal" href="#select.poll" title="select.poll"><code class="xref py py-func docutils literal"><span class="pre">poll()</span></code></a> or another interface in this module.  This doesn&#8217;t apply
to other kind of file-like objects such as sockets.</p>
<p>This value is guaranteed by POSIX to be at least 512.  Availability: Unix.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.2.</span></p>
</div>
</dd></dl>

<div class="section" id="dev-poll-polling-objects">
<span id="devpoll-objects"></span><h2>18.3.1. <code class="docutils literal"><span class="pre">/dev/poll</span></code> Polling Objects<a class="headerlink" href="#dev-poll-polling-objects" title="Permalink to this headline">¶</a></h2>
<p>Solaris and derivatives have <code class="docutils literal"><span class="pre">/dev/poll</span></code>. While <code class="xref c c-func docutils literal"><span class="pre">select()</span></code> is
O(highest file descriptor) and <code class="xref c c-func docutils literal"><span class="pre">poll()</span></code> is O(number of file
descriptors), <code class="docutils literal"><span class="pre">/dev/poll</span></code> is O(active file descriptors).</p>
<p><code class="docutils literal"><span class="pre">/dev/poll</span></code> behaviour is very close to the standard <code class="xref c c-func docutils literal"><span class="pre">poll()</span></code>
object.</p>
<dl class="method">
<dt id="select.devpoll.close">
<code class="descclassname">devpoll.</code><code class="descname">close</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#select.devpoll.close" title="Permalink to this definition">¶</a></dt>
<dd><p>Close the file descriptor of the polling object.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4.</span></p>
</div>
</dd></dl>

<dl class="attribute">
<dt id="select.devpoll.closed">
<code class="descclassname">devpoll.</code><code class="descname">closed</code><a class="headerlink" href="#select.devpoll.closed" title="Permalink to this definition">¶</a></dt>
<dd><p><code class="docutils literal"><span class="pre">True</span></code> if the polling object is closed.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4.</span></p>
</div>
</dd></dl>

<dl class="method">
<dt id="select.devpoll.fileno">
<code class="descclassname">devpoll.</code><code class="descname">fileno</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#select.devpoll.fileno" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the file descriptor number of the polling object.</p>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.4.</span></p>
</div>
</dd></dl>

<dl class="method">
<dt id="select.devpoll.register">
<code class="descclassname">devpoll.</code><code class="descname">register</code><span class="sig-paren">(</span><em>fd</em><span class="optional">[</span>, <em>eventmask</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#select.devpoll.register" title="Permalink to this definition">¶</a></dt>
<dd><p>Register a file descriptor with the polling object.  Future calls to the
<a class="reference internal" href="#select.poll" title="select.poll"><code class="xref py py-meth docutils literal"><span class="pre">poll()</span></code></a> method will then check whether the file descriptor has any
pending I/O events.  <em>fd</em> can be either an integer, or an object with a
<a class="reference internal" href="io.html#io.IOBase.fileno" title="io.IOBase.fileno"><code class="xref py py-meth docutils literal"><span class="pre">fileno()</span></code></a> method that returns an integer.  File objects
implement <code class="xref py py-meth docutils literal"><span class="pre">fileno()</span></code>, so they can also be used as the argument.</p>
<p><em>eventmask</em> is an optional bitmask describing the type of events you want to
check for. The constants are the same that with <code class="xref c c-func docutils literal"><span class="pre">poll()</span></code>
object. The default value is a combination of the constants <code class="xref py py-const docutils literal"><span class="pre">POLLIN</span></code>,
<code class="xref py py-const docutils literal"><span class="pre">POLLPRI</span></code>, and <code class="xref py py-const docutils literal"><span class="pre">POLLOUT</span></code>.</p>
<div class="admonition warning">
<p class="first admonition-title">Warning</p>
<p class="last">Registering a file descriptor that&#8217;s already registered is not an
error, but the result is undefined. The appropriate action is to
unregister or modify it first. This is an important difference
compared with <code class="xref c c-func docutils literal"><span class="pre">poll()</span></code>.</p>
</div>
</dd></dl>

<dl class="method">
<dt id="select.devpoll.modify">
<code class="descclassname">devpoll.</code><code class="descname">modify</code><span class="sig-paren">(</span><em>fd</em><span class="optional">[</span>, <em>eventmask</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#select.devpoll.modify" title="Permalink to this definition">¶</a></dt>
<dd><p>This method does an <a class="reference internal" href="#select.devpoll.unregister" title="select.devpoll.unregister"><code class="xref py py-meth docutils literal"><span class="pre">unregister()</span></code></a> followed by a
<a class="reference internal" href="#select.devpoll.register" title="select.devpoll.register"><code class="xref py py-meth docutils literal"><span class="pre">register()</span></code></a>. It is (a bit) more efficient that doing the same
explicitly.</p>
</dd></dl>

<dl class="method">
<dt id="select.devpoll.unregister">
<code class="descclassname">devpoll.</code><code class="descname">unregister</code><span class="sig-paren">(</span><em>fd</em><span class="sig-paren">)</span><a class="headerlink" href="#select.devpoll.unregister" title="Permalink to this definition">¶</a></dt>
<dd><p>Remove a file descriptor being tracked by a polling object.  Just like the
<a class="reference internal" href="#select.devpoll.register" title="select.devpoll.register"><code class="xref py py-meth docutils literal"><span class="pre">register()</span></code></a> method, <em>fd</em> can be an integer or an object with a
<a class="reference internal" href="io.html#io.IOBase.fileno" title="io.IOBase.fileno"><code class="xref py py-meth docutils literal"><span class="pre">fileno()</span></code></a> method that returns an integer.</p>
<p>Attempting to remove a file descriptor that was never registered is
safely ignored.</p>
</dd></dl>

<dl class="method">
<dt id="select.devpoll.poll">
<code class="descclassname">devpoll.</code><code class="descname">poll</code><span class="sig-paren">(</span><span class="optional">[</span><em>timeout</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#select.devpoll.poll" title="Permalink to this definition">¶</a></dt>
<dd><p>Polls the set of registered file descriptors, and returns a possibly-empty list
containing <code class="docutils literal"><span class="pre">(fd,</span> <span class="pre">event)</span></code> 2-tuples for the descriptors that have events or
errors to report. <em>fd</em> is the file descriptor, and <em>event</em> is a bitmask with
bits set for the reported events for that descriptor &#8212; <code class="xref py py-const docutils literal"><span class="pre">POLLIN</span></code> for
waiting input, <code class="xref py py-const docutils literal"><span class="pre">POLLOUT</span></code> to indicate that the descriptor can be written
to, and so forth. An empty list indicates that the call timed out and no file
descriptors had any events to report. If <em>timeout</em> is given, it specifies the
length of time in milliseconds which the system will wait for events before
returning. If <em>timeout</em> is omitted, -1, or <a class="reference internal" href="constants.html#None" title="None"><code class="xref py py-const docutils literal"><span class="pre">None</span></code></a>, the call will
block until there is an event for this poll object.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span>The function is now retried with a recomputed timeout when interrupted by
a signal, except if the signal handler raises an exception (see
<span class="target" id="index-4"></span><a class="pep reference external" href="https://www.python.org/dev/peps/pep-0475"><strong>PEP 475</strong></a> for the rationale), instead of raising
<a class="reference internal" href="exceptions.html#InterruptedError" title="InterruptedError"><code class="xref py py-exc docutils literal"><span class="pre">InterruptedError</span></code></a>.</p>
</div>
</dd></dl>

</div>
<div class="section" id="edge-and-level-trigger-polling-epoll-objects">
<span id="epoll-objects"></span><h2>18.3.2. Edge and Level Trigger Polling (epoll) Objects<a class="headerlink" href="#edge-and-level-trigger-polling-epoll-objects" title="Permalink to this headline">¶</a></h2>
<blockquote>
<div><p><a class="reference external" href="http://linux.die.net/man/4/epoll">http://linux.die.net/man/4/epoll</a></p>
<p><em>eventmask</em></p>
<table border="1" class="docutils">
<colgroup>
<col width="33%" />
<col width="67%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Constant</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">EPOLLIN</span></code></td>
<td>Available for read</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">EPOLLOUT</span></code></td>
<td>Available for write</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">EPOLLPRI</span></code></td>
<td>Urgent data for read</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">EPOLLERR</span></code></td>
<td>Error condition happened on the assoc. fd</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">EPOLLHUP</span></code></td>
<td>Hang up happened on the assoc. fd</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">EPOLLET</span></code></td>
<td>Set Edge Trigger behavior, the default is
Level Trigger behavior</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">EPOLLONESHOT</span></code></td>
<td>Set one-shot behavior. After one event is
pulled out, the fd is internally disabled</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">EPOLLRDNORM</span></code></td>
<td>Equivalent to <code class="xref py py-const docutils literal"><span class="pre">EPOLLIN</span></code></td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">EPOLLRDBAND</span></code></td>
<td>Priority data band can be read.</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">EPOLLWRNORM</span></code></td>
<td>Equivalent to <code class="xref py py-const docutils literal"><span class="pre">EPOLLOUT</span></code></td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">EPOLLWRBAND</span></code></td>
<td>Priority data may be written.</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">EPOLLMSG</span></code></td>
<td>Ignored.</td>
</tr>
</tbody>
</table>
</div></blockquote>
<dl class="method">
<dt id="select.epoll.close">
<code class="descclassname">epoll.</code><code class="descname">close</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#select.epoll.close" title="Permalink to this definition">¶</a></dt>
<dd><p>Close the control file descriptor of the epoll object.</p>
</dd></dl>

<dl class="attribute">
<dt id="select.epoll.closed">
<code class="descclassname">epoll.</code><code class="descname">closed</code><a class="headerlink" href="#select.epoll.closed" title="Permalink to this definition">¶</a></dt>
<dd><p><code class="docutils literal"><span class="pre">True</span></code> if the epoll object is closed.</p>
</dd></dl>

<dl class="method">
<dt id="select.epoll.fileno">
<code class="descclassname">epoll.</code><code class="descname">fileno</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#select.epoll.fileno" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the file descriptor number of the control fd.</p>
</dd></dl>

<dl class="method">
<dt id="select.epoll.fromfd">
<code class="descclassname">epoll.</code><code class="descname">fromfd</code><span class="sig-paren">(</span><em>fd</em><span class="sig-paren">)</span><a class="headerlink" href="#select.epoll.fromfd" title="Permalink to this definition">¶</a></dt>
<dd><p>Create an epoll object from a given file descriptor.</p>
</dd></dl>

<dl class="method">
<dt id="select.epoll.register">
<code class="descclassname">epoll.</code><code class="descname">register</code><span class="sig-paren">(</span><em>fd</em><span class="optional">[</span>, <em>eventmask</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#select.epoll.register" title="Permalink to this definition">¶</a></dt>
<dd><p>Register a fd descriptor with the epoll object.</p>
</dd></dl>

<dl class="method">
<dt id="select.epoll.modify">
<code class="descclassname">epoll.</code><code class="descname">modify</code><span class="sig-paren">(</span><em>fd</em>, <em>eventmask</em><span class="sig-paren">)</span><a class="headerlink" href="#select.epoll.modify" title="Permalink to this definition">¶</a></dt>
<dd><p>Modify a registered file descriptor.</p>
</dd></dl>

<dl class="method">
<dt id="select.epoll.unregister">
<code class="descclassname">epoll.</code><code class="descname">unregister</code><span class="sig-paren">(</span><em>fd</em><span class="sig-paren">)</span><a class="headerlink" href="#select.epoll.unregister" title="Permalink to this definition">¶</a></dt>
<dd><p>Remove a registered file descriptor from the epoll object.</p>
</dd></dl>

<dl class="method">
<dt id="select.epoll.poll">
<code class="descclassname">epoll.</code><code class="descname">poll</code><span class="sig-paren">(</span><em>timeout=-1</em>, <em>maxevents=-1</em><span class="sig-paren">)</span><a class="headerlink" href="#select.epoll.poll" title="Permalink to this definition">¶</a></dt>
<dd><p>Wait for events. timeout in seconds (float)</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span>The function is now retried with a recomputed timeout when interrupted by
a signal, except if the signal handler raises an exception (see
<span class="target" id="index-5"></span><a class="pep reference external" href="https://www.python.org/dev/peps/pep-0475"><strong>PEP 475</strong></a> for the rationale), instead of raising
<a class="reference internal" href="exceptions.html#InterruptedError" title="InterruptedError"><code class="xref py py-exc docutils literal"><span class="pre">InterruptedError</span></code></a>.</p>
</div>
</dd></dl>

</div>
<div class="section" id="polling-objects">
<span id="poll-objects"></span><h2>18.3.3. Polling Objects<a class="headerlink" href="#polling-objects" title="Permalink to this headline">¶</a></h2>
<p>The <code class="xref c c-func docutils literal"><span class="pre">poll()</span></code> system call, supported on most Unix systems, provides better
scalability for network servers that service many, many clients at the same
time. <code class="xref c c-func docutils literal"><span class="pre">poll()</span></code> scales better because the system call only requires listing
the file descriptors of interest, while <code class="xref c c-func docutils literal"><span class="pre">select()</span></code> builds a bitmap, turns
on bits for the fds of interest, and then afterward the whole bitmap has to be
linearly scanned again. <code class="xref c c-func docutils literal"><span class="pre">select()</span></code> is O(highest file descriptor), while
<code class="xref c c-func docutils literal"><span class="pre">poll()</span></code> is O(number of file descriptors).</p>
<dl class="method">
<dt id="select.poll.register">
<code class="descclassname">poll.</code><code class="descname">register</code><span class="sig-paren">(</span><em>fd</em><span class="optional">[</span>, <em>eventmask</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#select.poll.register" title="Permalink to this definition">¶</a></dt>
<dd><p>Register a file descriptor with the polling object.  Future calls to the
<a class="reference internal" href="#select.poll" title="select.poll"><code class="xref py py-meth docutils literal"><span class="pre">poll()</span></code></a> method will then check whether the file descriptor has any
pending I/O events.  <em>fd</em> can be either an integer, or an object with a
<a class="reference internal" href="io.html#io.IOBase.fileno" title="io.IOBase.fileno"><code class="xref py py-meth docutils literal"><span class="pre">fileno()</span></code></a> method that returns an integer.  File objects
implement <code class="xref py py-meth docutils literal"><span class="pre">fileno()</span></code>, so they can also be used as the argument.</p>
<p><em>eventmask</em> is an optional bitmask describing the type of events you want to
check for, and can be a combination of the constants <code class="xref py py-const docutils literal"><span class="pre">POLLIN</span></code>,
<code class="xref py py-const docutils literal"><span class="pre">POLLPRI</span></code>, and <code class="xref py py-const docutils literal"><span class="pre">POLLOUT</span></code>, described in the table below.  If not
specified, the default value used will check for all 3 types of events.</p>
<table border="1" class="docutils">
<colgroup>
<col width="31%" />
<col width="69%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Constant</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">POLLIN</span></code></td>
<td>There is data to read</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">POLLPRI</span></code></td>
<td>There is urgent data to read</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">POLLOUT</span></code></td>
<td>Ready for output: writing will not block</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">POLLERR</span></code></td>
<td>Error condition of some sort</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">POLLHUP</span></code></td>
<td>Hung up</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">POLLNVAL</span></code></td>
<td>Invalid request: descriptor not open</td>
</tr>
</tbody>
</table>
<p>Registering a file descriptor that&#8217;s already registered is not an error, and has
the same effect as registering the descriptor exactly once.</p>
</dd></dl>

<dl class="method">
<dt id="select.poll.modify">
<code class="descclassname">poll.</code><code class="descname">modify</code><span class="sig-paren">(</span><em>fd</em>, <em>eventmask</em><span class="sig-paren">)</span><a class="headerlink" href="#select.poll.modify" title="Permalink to this definition">¶</a></dt>
<dd><p>Modifies an already registered fd. This has the same effect as
<code class="docutils literal"><span class="pre">register(fd,</span> <span class="pre">eventmask)</span></code>.  Attempting to modify a file descriptor
that was never registered causes an <a class="reference internal" href="exceptions.html#OSError" title="OSError"><code class="xref py py-exc docutils literal"><span class="pre">OSError</span></code></a> exception with errno
<code class="xref py py-const docutils literal"><span class="pre">ENOENT</span></code> to be raised.</p>
</dd></dl>

<dl class="method">
<dt id="select.poll.unregister">
<code class="descclassname">poll.</code><code class="descname">unregister</code><span class="sig-paren">(</span><em>fd</em><span class="sig-paren">)</span><a class="headerlink" href="#select.poll.unregister" title="Permalink to this definition">¶</a></dt>
<dd><p>Remove a file descriptor being tracked by a polling object.  Just like the
<a class="reference internal" href="#select.poll.register" title="select.poll.register"><code class="xref py py-meth docutils literal"><span class="pre">register()</span></code></a> method, <em>fd</em> can be an integer or an object with a
<a class="reference internal" href="io.html#io.IOBase.fileno" title="io.IOBase.fileno"><code class="xref py py-meth docutils literal"><span class="pre">fileno()</span></code></a> method that returns an integer.</p>
<p>Attempting to remove a file descriptor that was never registered causes a
<a class="reference internal" href="exceptions.html#KeyError" title="KeyError"><code class="xref py py-exc docutils literal"><span class="pre">KeyError</span></code></a> exception to be raised.</p>
</dd></dl>

<dl class="method">
<dt id="select.poll.poll">
<code class="descclassname">poll.</code><code class="descname">poll</code><span class="sig-paren">(</span><span class="optional">[</span><em>timeout</em><span class="optional">]</span><span class="sig-paren">)</span><a class="headerlink" href="#select.poll.poll" title="Permalink to this definition">¶</a></dt>
<dd><p>Polls the set of registered file descriptors, and returns a possibly-empty list
containing <code class="docutils literal"><span class="pre">(fd,</span> <span class="pre">event)</span></code> 2-tuples for the descriptors that have events or
errors to report. <em>fd</em> is the file descriptor, and <em>event</em> is a bitmask with
bits set for the reported events for that descriptor &#8212; <code class="xref py py-const docutils literal"><span class="pre">POLLIN</span></code> for
waiting input, <code class="xref py py-const docutils literal"><span class="pre">POLLOUT</span></code> to indicate that the descriptor can be written
to, and so forth. An empty list indicates that the call timed out and no file
descriptors had any events to report. If <em>timeout</em> is given, it specifies the
length of time in milliseconds which the system will wait for events before
returning. If <em>timeout</em> is omitted, negative, or <a class="reference internal" href="constants.html#None" title="None"><code class="xref py py-const docutils literal"><span class="pre">None</span></code></a>, the call will
block until there is an event for this poll object.</p>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span>The function is now retried with a recomputed timeout when interrupted by
a signal, except if the signal handler raises an exception (see
<span class="target" id="index-6"></span><a class="pep reference external" href="https://www.python.org/dev/peps/pep-0475"><strong>PEP 475</strong></a> for the rationale), instead of raising
<a class="reference internal" href="exceptions.html#InterruptedError" title="InterruptedError"><code class="xref py py-exc docutils literal"><span class="pre">InterruptedError</span></code></a>.</p>
</div>
</dd></dl>

</div>
<div class="section" id="kqueue-objects">
<span id="id1"></span><h2>18.3.4. Kqueue Objects<a class="headerlink" href="#kqueue-objects" title="Permalink to this headline">¶</a></h2>
<dl class="method">
<dt id="select.kqueue.close">
<code class="descclassname">kqueue.</code><code class="descname">close</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#select.kqueue.close" title="Permalink to this definition">¶</a></dt>
<dd><p>Close the control file descriptor of the kqueue object.</p>
</dd></dl>

<dl class="attribute">
<dt id="select.kqueue.closed">
<code class="descclassname">kqueue.</code><code class="descname">closed</code><a class="headerlink" href="#select.kqueue.closed" title="Permalink to this definition">¶</a></dt>
<dd><p><code class="docutils literal"><span class="pre">True</span></code> if the kqueue object is closed.</p>
</dd></dl>

<dl class="method">
<dt id="select.kqueue.fileno">
<code class="descclassname">kqueue.</code><code class="descname">fileno</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#select.kqueue.fileno" title="Permalink to this definition">¶</a></dt>
<dd><p>Return the file descriptor number of the control fd.</p>
</dd></dl>

<dl class="method">
<dt id="select.kqueue.fromfd">
<code class="descclassname">kqueue.</code><code class="descname">fromfd</code><span class="sig-paren">(</span><em>fd</em><span class="sig-paren">)</span><a class="headerlink" href="#select.kqueue.fromfd" title="Permalink to this definition">¶</a></dt>
<dd><p>Create a kqueue object from a given file descriptor.</p>
</dd></dl>

<dl class="method">
<dt id="select.kqueue.control">
<code class="descclassname">kqueue.</code><code class="descname">control</code><span class="sig-paren">(</span><em>changelist</em>, <em>max_events</em><span class="optional">[</span>, <em>timeout=None</em><span class="optional">]</span><span class="sig-paren">)</span> &rarr; eventlist<a class="headerlink" href="#select.kqueue.control" title="Permalink to this definition">¶</a></dt>
<dd><p>Low level interface to kevent</p>
<ul class="simple">
<li>changelist must be an iterable of kevent object or None</li>
<li>max_events must be 0 or a positive integer</li>
<li>timeout in seconds (floats possible)</li>
</ul>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5: </span>The function is now retried with a recomputed timeout when interrupted by
a signal, except if the signal handler raises an exception (see
<span class="target" id="index-7"></span><a class="pep reference external" href="https://www.python.org/dev/peps/pep-0475"><strong>PEP 475</strong></a> for the rationale), instead of raising
<a class="reference internal" href="exceptions.html#InterruptedError" title="InterruptedError"><code class="xref py py-exc docutils literal"><span class="pre">InterruptedError</span></code></a>.</p>
</div>
</dd></dl>

</div>
<div class="section" id="kevent-objects">
<span id="id2"></span><h2>18.3.5. Kevent Objects<a class="headerlink" href="#kevent-objects" title="Permalink to this headline">¶</a></h2>
<p><a class="reference external" href="http://www.freebsd.org/cgi/man.cgi?query=kqueue&amp;sektion=2">http://www.freebsd.org/cgi/man.cgi?query=kqueue&amp;sektion=2</a></p>
<dl class="attribute">
<dt id="select.kevent.ident">
<code class="descclassname">kevent.</code><code class="descname">ident</code><a class="headerlink" href="#select.kevent.ident" title="Permalink to this definition">¶</a></dt>
<dd><p>Value used to identify the event. The interpretation depends on the filter
but it&#8217;s usually the file descriptor. In the constructor ident can either
be an int or an object with a <a class="reference internal" href="io.html#io.IOBase.fileno" title="io.IOBase.fileno"><code class="xref py py-meth docutils literal"><span class="pre">fileno()</span></code></a> method. kevent
stores the integer internally.</p>
</dd></dl>

<dl class="attribute">
<dt id="select.kevent.filter">
<code class="descclassname">kevent.</code><code class="descname">filter</code><a class="headerlink" href="#select.kevent.filter" title="Permalink to this definition">¶</a></dt>
<dd><p>Name of the kernel filter.</p>
<table border="1" class="docutils">
<colgroup>
<col width="38%" />
<col width="63%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Constant</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_READ</span></code></td>
<td>Takes a descriptor and returns whenever
there is data available to read</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_WRITE</span></code></td>
<td>Takes a descriptor and returns whenever
there is data available to write</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_AIO</span></code></td>
<td>AIO requests</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_VNODE</span></code></td>
<td>Returns when one or more of the requested
events watched in <em>fflag</em> occurs</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_PROC</span></code></td>
<td>Watch for events on a process id</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_NETDEV</span></code></td>
<td>Watch for events on a network device
[not available on Mac OS X]</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_SIGNAL</span></code></td>
<td>Returns whenever the watched signal is
delivered to the process</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_TIMER</span></code></td>
<td>Establishes an arbitrary timer</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="select.kevent.flags">
<code class="descclassname">kevent.</code><code class="descname">flags</code><a class="headerlink" href="#select.kevent.flags" title="Permalink to this definition">¶</a></dt>
<dd><p>Filter action.</p>
<table border="1" class="docutils">
<colgroup>
<col width="38%" />
<col width="63%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Constant</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_EV_ADD</span></code></td>
<td>Adds or modifies an event</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_EV_DELETE</span></code></td>
<td>Removes an event from the queue</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_EV_ENABLE</span></code></td>
<td>Permitscontrol() to returns the event</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_EV_DISABLE</span></code></td>
<td>Disablesevent</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_EV_ONESHOT</span></code></td>
<td>Removes event after first occurrence</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_EV_CLEAR</span></code></td>
<td>Reset the state after an event is retrieved</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_EV_SYSFLAGS</span></code></td>
<td>internal event</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_EV_FLAG1</span></code></td>
<td>internal event</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_EV_EOF</span></code></td>
<td>Filter specific EOF condition</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_EV_ERROR</span></code></td>
<td>See return values</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="select.kevent.fflags">
<code class="descclassname">kevent.</code><code class="descname">fflags</code><a class="headerlink" href="#select.kevent.fflags" title="Permalink to this definition">¶</a></dt>
<dd><p>Filter specific flags.</p>
<p><code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_READ</span></code> and  <code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_WRITE</span></code> filter flags:</p>
<table border="1" class="docutils">
<colgroup>
<col width="39%" />
<col width="61%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Constant</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_LOWAT</span></code></td>
<td>low water mark of a socket buffer</td>
</tr>
</tbody>
</table>
<p><code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_VNODE</span></code> filter flags:</p>
<table border="1" class="docutils">
<colgroup>
<col width="39%" />
<col width="61%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Constant</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_DELETE</span></code></td>
<td><em>unlink()</em> was called</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_WRITE</span></code></td>
<td>a write occurred</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_EXTEND</span></code></td>
<td>the file was extended</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_ATTRIB</span></code></td>
<td>an attribute was changed</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_LINK</span></code></td>
<td>the link count has changed</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_RENAME</span></code></td>
<td>the file was renamed</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_REVOKE</span></code></td>
<td>access to the file was revoked</td>
</tr>
</tbody>
</table>
<p><code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_PROC</span></code> filter flags:</p>
<table border="1" class="docutils">
<colgroup>
<col width="39%" />
<col width="61%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Constant</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_EXIT</span></code></td>
<td>the process has exited</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_FORK</span></code></td>
<td>the process has called <em>fork()</em></td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_EXEC</span></code></td>
<td>the process has executed a new process</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_PCTRLMASK</span></code></td>
<td>internal filter flag</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_PDATAMASK</span></code></td>
<td>internal filter flag</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_TRACK</span></code></td>
<td>follow a process across <em>fork()</em></td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_CHILD</span></code></td>
<td>returned on the child process for
<em>NOTE_TRACK</em></td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_TRACKERR</span></code></td>
<td>unable to attach to a child</td>
</tr>
</tbody>
</table>
<p><code class="xref py py-const docutils literal"><span class="pre">KQ_FILTER_NETDEV</span></code> filter flags (not available on Mac OS X):</p>
<table border="1" class="docutils">
<colgroup>
<col width="39%" />
<col width="61%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Constant</th>
<th class="head">Meaning</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_LINKUP</span></code></td>
<td>link is up</td>
</tr>
<tr class="row-odd"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_LINKDOWN</span></code></td>
<td>link is down</td>
</tr>
<tr class="row-even"><td><code class="xref py py-const docutils literal"><span class="pre">KQ_NOTE_LINKINV</span></code></td>
<td>link state is invalid</td>
</tr>
</tbody>
</table>
</dd></dl>

<dl class="attribute">
<dt id="select.kevent.data">
<code class="descclassname">kevent.</code><code class="descname">data</code><a class="headerlink" href="#select.kevent.data" title="Permalink to this definition">¶</a></dt>
<dd><p>Filter specific data.</p>
</dd></dl>

<dl class="attribute">
<dt id="select.kevent.udata">
<code class="descclassname">kevent.</code><code class="descname">udata</code><a class="headerlink" href="#select.kevent.udata" title="Permalink to this definition">¶</a></dt>
<dd><p>User defined value.</p>
</dd></dl>

</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">18.3. <code class="docutils literal"><span class="pre">select</span></code> &#8212; Waiting for I/O completion</a><ul>
<li><a class="reference internal" href="#dev-poll-polling-objects">18.3.1. <code class="docutils literal"><span class="pre">/dev/poll</span></code> Polling Objects</a></li>
<li><a class="reference internal" href="#edge-and-level-trigger-polling-epoll-objects">18.3.2. Edge and Level Trigger Polling (epoll) Objects</a></li>
<li><a class="reference internal" href="#polling-objects">18.3.3. Polling Objects</a></li>
<li><a class="reference internal" href="#kqueue-objects">18.3.4. Kqueue Objects</a></li>
<li><a class="reference internal" href="#kevent-objects">18.3.5. Kevent Objects</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="ssl.html"
                        title="previous chapter">18.2. <code class="docutils literal"><span class="pre">ssl</span></code> &#8212; TLS/SSL wrapper for socket objects</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="selectors.html"
                        title="next chapter">18.4. <code class="docutils literal"><span class="pre">selectors</span></code> &#8211; High-level I/O multiplexing</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/library/select.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="selectors.html" title="18.4. selectors – High-level I/O multiplexing"
             >next</a> |</li>
        <li class="right" >
          <a href="ssl.html" title="18.2. ssl — TLS/SSL wrapper for socket objects"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >The Python Standard Library</a> &raquo;</li>
          <li class="nav-item nav-item-2"><a href="ipc.html" >18. Interprocess Communication and Networking</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 08, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>